//Wrapper Dll Template Maker v1.0

#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <imagehlp.h>

BOOL CALLBACK Callback(LPSTR modulename, ULONG base, PVOID user)
{
	printf("%s\n", modulename);
	return TRUE;
}

void main(int argc, char **argv)
{
	PIMAGE_NT_HEADERS pnth;
	PIMAGE_EXPORT_DIRECTORY pedir;
	DWORD base, rva = 0;
	DWORD *nametable;
	WORD *ordinaltable;
	int i;
	FILE *fp;
	char *src = 0, *out = 0;
	char outcpp[MAX_PATH], outdef[MAX_PATH];
	
	for(i = 1; i < argc; i ++){
		if(*(argv[i]) == '-'){
			if(!strcmp(argv[i], "-o")){
				i ++;
				if(i == argc){
					src = 0;
					break;
				}
				out = argv[i];
			}
			else{
				src = 0;
				break;
			}
		}
		else{
			if(src){
				src = 0;
				break;
			}
			src = argv[i];
		}
	}
	
	if(!src){
		printf("WRAPPER DLL TEMPLATE MAKER V1.0\n%s {sourcefile} [-o {outputfile}]\n", argv[0]);
		return;
	}
	
	if(!out){
		out = strdup(src);
		i = strlen(out) - 1;
		while(out[i] != '.' && i) i --;
		if(i) out[i] = 0;
	}
	
	strcpy(outcpp, out);
	strcat(outcpp, ".c");
	strcpy(outdef, out);
	strcat(outdef, ".def");
	
	base = (DWORD)LoadLibrary(src);
	if(!base){
		printf("%s not found.\n", src);
		return;
	}
	pnth = PIMAGE_NT_HEADERS(PBYTE(base) + PIMAGE_DOS_HEADER(base)->e_lfanew);
	if(pnth) rva = pnth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress;
	pedir = (PIMAGE_EXPORT_DIRECTORY)(base + rva);
	
	if(!rva || pedir->NumberOfNames == 0){
		printf("No exported functions!\n");
		FreeLibrary((HINSTANCE)base);
		return;
	}
	
	nametable = (DWORD *)(pedir->AddressOfNames + base);
	ordinaltable = (WORD *)(pedir->AddressOfNameOrdinals + base);

	
	fp = fopen(outcpp, "wt");
	fprintf(fp, "#include <windows.h>\n#include <string.h>\n");
	fprintf(fp, "#pragma warning(disable: 4731)\n\n");
	for(i = 0; i < pedir->NumberOfNames; i ++){
		if(!strcmp((char *)(nametable[i] + base), "DllCanUnloadNow")) continue;
		if(!strcmp((char *)(nametable[i] + base), "DllGetClassObject")) continue;		
		fprintf(fp, "void *g_p%s;\n", nametable[i] + base);
	}
	fprintf(fp, "\n");
	for(i = 0; i < pedir->NumberOfNames; i ++){
		if(!strcmp((char *)(nametable[i] + base), "DllCanUnloadNow")) continue;
		if(!strcmp((char *)(nametable[i] + base), "DllGetClassObject")) continue;		
		fprintf(fp, "void %s(void){__asm pop ebp __asm jmp g_p%s}\n", nametable[i] + base, nametable[i] + base);
	}
	fprintf(fp, "\n\nBOOL APIENTRY DllMain(HANDLE hmodule, DWORD  dwreason, LPVOID preserved)\n{\n");
	fprintf(fp, "\tstatic HINSTANCE hinst;\n\tchar path[MAX_PATH];\n\n");
	fprintf(fp, "\tif(dwreason == DLL_PROCESS_DETACH){\n\t\tFreeLibrary(hinst);\n\t}\n");
	fprintf(fp, "\tif(dwreason != DLL_PROCESS_ATTACH) return TRUE;\n\n");
	fprintf(fp, "\tGetSystemDirectory(path, MAX_PATH);\n");
	fprintf(fp, "\tstrcat(path, \"\\\\%s\");\n", src);
	fprintf(fp, "\thinst = LoadLibrary(path);\n");
	fprintf(fp, "\tif(!hinst) return FALSE;\n\n");
	for(i = 0;i < pedir->NumberOfNames; i ++){
		if(!strcmp((char *)(nametable[i] + base), "DllCanUnloadNow")) continue;
		if(!strcmp((char *)(nametable[i] + base), "DllGetClassObject")) continue;		
		fprintf(fp, "\tg_p%s = GetProcAddress(hinst, \"%s\");\n", nametable[i] + base, nametable[i] + base);
	}
	fprintf(fp, "\n\treturn TRUE;\n}\n");
	fclose(fp);
	
	fp = fopen(outdef, "wt");
	fprintf(fp, "LIBRARY %s\nEXPORTS\n", out);
	for(i = 0; i < pedir->NumberOfNames; i ++){
		if(!strcmp((char *)(nametable[i] + base), "DllCanUnloadNow")) continue;
		if(!strcmp((char *)(nametable[i] + base), "DllGetClassObject")) continue;		
		fprintf(fp, "\t\t%s\t@%i\n", nametable[i] + base, ordinaltable[i] + 1);
	}
	fclose(fp);
	
	FreeLibrary((HINSTANCE)base);
}
